const int analogOutPin = 6; // Servo is connected to pin 6


void setup() {
  pinMode(6, OUTPUT);  
  setPwmFrequency(6, 8); //~7.8KHz output freq. (TCCR0B = (1 << CS01);) 
  analogWrite(analogOutPin, 50);
  
  Serial.begin(9600);
  Serial.print("Enter servo position...");
}

void loop() {
  if (Serial.available() > 0)
  {
    String angle_str = Serial.readString();
    int angle=angle_str.toInt();
    int duty=map(angle, 0, 360, 40, 225);
    analogWrite(analogOutPin, duty);
  }
}

void setPwmFrequency(int pin, int divisor) {
  byte mode;
  if(pin == 5 || pin == 6 || pin == 9 || pin == 10) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 64: mode = 0x03; break;
      case 256: mode = 0x04; break;
      case 1024: mode = 0x05; break;
      default: return;
    }
    if(pin == 5 || pin == 6) {
      TCCR0B = TCCR0B & 0b11111000 | mode;
    } else {
      TCCR1B = TCCR1B & 0b11111000 | mode;
    }
  } else if(pin == 3 || pin == 11) {
    switch(divisor) {
      case 1: mode = 0x01; break;
      case 8: mode = 0x02; break;
      case 32: mode = 0x03; break;
      case 64: mode = 0x04; break;
      case 128: mode = 0x05; break;
      case 256: mode = 0x06; break;
      case 1024: mode = 0x07; break;
      default: return;
    }
    TCCR2B = TCCR2B & 0b11111000 | mode;
  }
}
